## z3 4.8.7

=== CMakeLists.txt ===
# Enforce some CMake policies
cmake_minimum_required(VERSION 3.4)

if (POLICY CMP0054)
  cmake_policy(SET CMP0054 NEW)
endif()

if (POLICY CMP0042)
  # Enable `MACOSX_RPATH` by default.
  cmake_policy(SET CMP0042 NEW)
endif()

set(CMAKE_USER_MAKE_RULES_OVERRIDE_CXX "${CMAKE_CURRENT_SOURCE_DIR}/cmake/cxx_compiler_flags_overrides.cmake")
project(Z3 VERSION 4.8.7.0 LANGUAGES CXX)

################################################################################
# Project version
################################################################################
set(Z3_FULL_VERSION_STR "${Z3_VERSION}") # Note this might be modified
message(STATUS "Z3 version ${Z3_VERSION}")

################################################################################
# Set various useful variables depending on CMake version
################################################################################

set(ADD_CUSTOM_COMMAND_USES_TERMINAL_ARG "USES_TERMINAL")
set(ADD_CUSTOM_TARGET_USES_TERMINAL_ARG "USES_TERMINAL")

################################################################################
# Message for polluted source tree sanity checks
################################################################################
set(z3_polluted_tree_msg
  " should not exist and is polluting the source tree."
  " It is likely that this file came from the Python build system which"
  " generates files inside the source tree. This is bad practice and the CMake"
  " build system is setup to make sure that the source tree is clean during"
  " its configure step. If you are using git you can remove all untracked files"
  " using ``git clean -fx``. Be careful when doing this. You should probably use"
  " this with ``-n`` first to check which file(s) would be removed."
)

################################################################################
# Sanity check - Disallow building in source
################################################################################
if ("${PROJECT_SOURCE_DIR}" STREQUAL "${PROJECT_BINARY_DIR}")
  message(FATAL_ERROR "In source builds are not allowed. You should invoke "
          "CMake from a different directory.")
endif()

################################################################################
# Add our CMake module directory to the list of module search directories
################################################################################
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake/modules")

################################################################################
# Handle git hash and description
################################################################################
include(${PROJECT_SOURCE_DIR}/cmake/git_utils.cmake)
macro(disable_git_describe)
  message(WARNING "Disabling Z3_INCLUDE_GIT_DESCRIBE")
  set(Z3_INCLUDE_GIT_DESCRIBE OFF CACHE BOOL "Include git describe output in version output" FORCE)
endmacro()
macro(disable_git_hash)
  message(WARNING "Disabling Z3_INCLUDE_GIT_HASH")
  set(Z3_INCLUDE_GIT_HASH OFF CACHE BOOL "Include git hash in version output" FORCE)
  unset(Z3GITHASH) # Used in configure_file()
endmacro()
option(Z3_INCLUDE_GIT_HASH "Include git hash in version output" ON)
option(Z3_INCLUDE_GIT_DESCRIBE "Include git describe output in version output" ON)

set(GIT_DIR "${PROJECT_SOURCE_DIR}/.git")
if (EXISTS "${GIT_DIR}")
  # Try to make CMake configure depend on the current git HEAD so that
  # a re-configure is triggered when the HEAD changes.
  add_git_dir_dependency("${PROJECT_SOURCE_DIR}" ADD_GIT_DEP_SUCCESS)
  if (ADD_GIT_DEP_SUCCESS)
    if (Z3_INCLUDE_GIT_HASH)
      get_git_head_hash("${GIT_DIR}" Z3GITHASH)
      if (NOT Z3GITHASH)
        message(WARNING "Failed to get Git hash")
        disable_git_hash()
      endif()
      message(STATUS "Using Git hash in version output: ${Z3GITHASH}")
      # This mimics the behaviour of the old build system.
      set(Z3_FULL_VERSION_STR "${Z3_FULL_VERSION_STR} ${Z3GITHASH}")
    else()
      message(STATUS "Not using Git hash in version output")
      unset(Z3GITHASH) # Used in configure_file()
    endif()
    if (Z3_INCLUDE_GIT_DESCRIBE)
      get_git_head_describe("${GIT_DIR}" Z3_GIT_DESCRIPTION)
      if (NOT Z3_GIT_DESCRIPTION)
        message(WARNING "Failed to get Git description")
        disable_git_describe()
      endif()
      message(STATUS "Using Git description in version output: ${Z3_GIT_DESCRIPTION}")
      # This mimics the behaviour of the old build system.
      set(Z3_FULL_VERSION_STR "${Z3_FULL_VERSION_STR} ${Z3_GIT_DESCRIPTION}")
    else()
      message(STATUS "Not including git descrption in version")
    endif()
  else()
    message(WARNING "Failed to add git dependency.")
    disable_git_describe()
    disable_git_hash()
  endif()
else()
  message(STATUS "Failed to find git directory.")
  disable_git_describe()
  disable_git_hash()
endif()

################################################################################
# Useful CMake functions/Macros
################################################################################
include(CheckCXXSourceCompiles)

################################################################################
# Compiler flags for Z3 components.
# Subsequent commands will append to this
################################################################################
set(Z3_COMPONENT_CXX_DEFINES "")
set(Z3_COMPONENT_CXX_FLAGS "")
set(Z3_COMPONENT_EXTRA_INCLUDE_DIRS "")
set(Z3_DEPENDENT_LIBS "")
set(Z3_DEPENDENT_EXTRA_CXX_LINK_FLAGS "")

################################################################################
# Build type
################################################################################
message(STATUS "CMake generator: ${CMAKE_GENERATOR}")
set(available_build_types Debug Release RelWithDebInfo MinSizeRel)
if (DEFINED CMAKE_CONFIGURATION_TYPES)
  # Multi-configuration build (e.g. Visual Studio and Xcode). Here
  # CMAKE_BUILD_TYPE doesn't matter
  message(STATUS "Available configurations: ${CMAKE_CONFIGURATION_TYPES}")
else()
  # Single configuration generator (e.g. Unix Makefiles, Ninja)
  if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "CMAKE_BUILD_TYPE is not set. Setting default")
    message(STATUS "The available build types are: ${available_build_types}")
    set(CMAKE_BUILD_TYPE RelWithDebInfo CACHE String
        "Options are ${available_build_types}"
        FORCE)
    # Provide drop down menu options in cmake-gui
    set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS ${available_build_types})
  endif()
  message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")

  # Check the selected build type is valid
  list(FIND available_build_types "${CMAKE_BUILD_TYPE}" _build_type_index)
  if ("${_build_type_index}" EQUAL "-1")
    message(FATAL_ERROR "\"${CMAKE_BUILD_TYPE}\" is an invalid build type.\n"
      "Use one of the following build types ${available_build_types}")
  endif()
endif()

# CMAKE_BUILD_TYPE has no meaning for multi-configuration generators
# (e.g. Visual Studio) so use generator expressions instead to add
# the right definitions when doing a particular build type.
#
# Note for some reason we have to leave off ``-D`` here otherwise
# we get ``-D-DZ3DEBUG`` passed to the compiler
list(APPEND Z3_COMPONENT_CXX_DEFINES $<$<CONFIG:Debug>:Z3DEBUG>)
list(APPEND Z3_COMPONENT_CXX_DEFINES $<$<CONFIG:Release>:_EXTERNAL_RELEASE>)
list(APPEND Z3_COMPONENT_CXX_DEFINES $<$<CONFIG:RelWithDebInfo>:_EXTERNAL_RELEASE>)

################################################################################
# Find Python
################################################################################
find_package(PythonInterp REQUIRED)
message(STATUS "PYTHON_EXECUTABLE: ${PYTHON_EXECUTABLE}")

################################################################################
# Target architecture detection
################################################################################
include(${PROJECT_SOURCE_DIR}/cmake/target_arch_detect.cmake)
detect_target_architecture(TARGET_ARCHITECTURE)
message(STATUS "Detected target architecture: ${TARGET_ARCHITECTURE}")


################################################################################
# Function for detecting C++ compiler flag support
################################################################################
include(${PROJECT_SOURCE_DIR}/cmake/z3_add_cxx_flag.cmake)

################################################################################
# C++ language version
################################################################################
set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

################################################################################
# Platform detection
################################################################################
if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Linux")
  message(STATUS "Platform: Linux")
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-D_LINUX_")
  if ("${TARGET_ARCHITECTURE}" STREQUAL "x86_64")
    list(APPEND Z3_COMPONENT_CXX_DEFINES "-D_USE_THREAD_LOCAL")
  endif()
elseif ("${CMAKE_SYSTEM_NAME}" MATCHES "GNU")
  message(STATUS "Platform: GNU/Hurd")
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-D_HURD_")
elseif ("${CMAKE_SYSTEM_NAME}" STREQUAL "Darwin")
  # Does macOS really not need any special flags?
  message(STATUS "Platform: Darwin")
elseif ("${CMAKE_SYSTEM_NAME}" MATCHES "FreeBSD")
  message(STATUS "Platform: FreeBSD")
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-D_FREEBSD_")
elseif ("${CMAKE_SYSTEM_NAME}" MATCHES "NetBSD")
  message(STATUS "Platform: NetBSD")
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-D_NetBSD_")
elseif ("${CMAKE_SYSTEM_NAME}" MATCHES "OpenBSD")
  message(STATUS "Platform: OpenBSD")
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-D_OPENBSD_")
elseif (CYGWIN)
  message(STATUS "Platform: Cygwin")
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-D_CYGWIN")
elseif (WIN32)
  message(STATUS "Platform: Windows")
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-D_WINDOWS")
elseif (EMSCRIPTEN)
  message(STATUS "Platform: Emscripten")
  list(APPEND Z3_DEPENDENT_EXTRA_CXX_LINK_FLAGS
    "-Os"
    "-s ALLOW_MEMORY_GROWTH=1"
    "-s ASSERTIONS=0"
    "-s DISABLE_EXCEPTION_CATCHING=0"
    "-s ERROR_ON_UNDEFINED_SYMBOLS=1"
  )
else()
  message(FATAL_ERROR "Platform \"${CMAKE_SYSTEM_NAME}\" not recognised")
endif()

list(APPEND Z3_COMPONENT_EXTRA_INCLUDE_DIRS 
  "${PROJECT_BINARY_DIR}/src"
  "${PROJECT_SOURCE_DIR}/src"
)

################################################################################
# GNU multiple precision library support
################################################################################
option(Z3_USE_LIB_GMP "Use GNU Multiple Precision Library" OFF)
if (Z3_USE_LIB_GMP)
  # Because this is off by default we will make the configure fail if libgmp
  # can't be found
  find_package(GMP REQUIRED)
  message(STATUS "Using libgmp")
  list(APPEND Z3_DEPENDENT_LIBS ${GMP_C_LIBRARIES})
  list(APPEND Z3_COMPONENT_EXTRA_INCLUDE_DIRS ${GMP_INCLUDE_DIRS})
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-D_MP_GMP")
else()
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-D_MP_INTERNAL")
  message(STATUS "Not using libgmp")
endif()


################################################################################
# API Log sync
################################################################################
option(Z3_API_LOG_SYNC
  "Use locking when logging Z3 API calls (experimental)"
  OFF
)
if (Z3_API_LOG_SYNC)
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-DZ3_LOG_SYNC")
  message(STATUS "Using Z3_API_LOG_SYNC")
else()
  message(STATUS "Not using Z3_API_LOG_SYNC")
endif()

################################################################################
# Thread safe or not?
################################################################################
option(SINGLE_THREADED
  "Non-thread-safe build"
  OFF
)
if (SINGLE_THREADED)
  list(APPEND Z3_COMPONENT_CXX_DEFINES "-DSINGLE_THREAD")
  message(STATUS "Non-thread-safe build")
else()

=== doc/CMakeLists.txt ===
find_package(Doxygen REQUIRED)
message(STATUS "DOXYGEN_EXECUTABLE: \"${DOXYGEN_EXECUTABLE}\"")
message(STATUS "DOXYGEN_VERSION: \"${DOXYGEN_VERSION}\"")

set(DOC_DEST_DIR "${CMAKE_CURRENT_BINARY_DIR}/api")
set(DOC_TEMP_DIR "${CMAKE_CURRENT_BINARY_DIR}/temp")
set(MK_API_DOC_SCRIPT "${CMAKE_CURRENT_SOURCE_DIR}/mk_api_doc.py")

set(PYTHON_API_OPTIONS "")
set(DOTNET_API_OPTIONS "")
set(JAVA_API_OPTIONS "")
SET(DOC_EXTRA_DEPENDS "")

if (BUILD_PYTHON_BINDINGS)
  # FIXME: Don't hard code this path
  list(APPEND PYTHON_API_OPTIONS "--z3py-package-path" "${PROJECT_BINARY_DIR}/python/z3")
  list(APPEND DOC_EXTRA_DEPENDS "build_z3_python_bindings")
else()
  list(APPEND PYTHON_API_OPTIONS "--no-z3py")
endif()

if (BUILD_DOTNET_BINDINGS)
  # FIXME: Don't hard code these paths
  list(APPEND DOTNET_API_OPTIONS "--dotnet-search-paths"
    "${PROJECT_SOURCE_DIR}/src/api/dotnet"
    "${PROJECT_BINARY_DIR}/src/api/dotnet"
  )
  list(APPEND DOC_EXTRA_DEPENDS "build_z3_dotnet_bindings")
else()
  list(APPEND DOTNET_API_OPTIONS "--no-dotnet")
endif()

if (BUILD_JAVA_BINDINGS)
  # FIXME: Don't hard code these paths
  list(APPEND JAVA_API_OPTIONS "--java-search-paths"
    "${PROJECT_SOURCE_DIR}/src/api/java"
    "${PROJECT_BINARY_DIR}/src/api/java"
  )
  list(APPEND DOC_EXTRA_DEPENDS "build_z3_java_bindings")
else()
  list(APPEND JAVA_API_OPTIONS "--no-java")
endif()

option(Z3_ALWAYS_BUILD_DOCS "Always build documentation for API bindings" ON)
if (Z3_ALWAYS_BUILD_DOCS)
  set(ALWAYS_BUILD_DOCS_ARG "ALL")
else()
  set(ALWAYS_BUILD_DOCS_ARG "")
  # FIXME: This sucks but there doesn't seem to be a way to make the top level
  # install target depend on the `api_docs` target.
  message(WARNING "Building documentation for API bindings is not part of the"
    " all target. This may result in stale files being installed when running"
    " the install target. You should run the api_docs target before running"
    " the install target. Alternatively Set Z3_ALWAYS_BUILD_DOCS to ON to"
    " automatically build documentation when running the install target."
  )
endif()

add_custom_target(api_docs ${ALWAYS_BUILD_DOCS_ARG}
  COMMAND
  "${PYTHON_EXECUTABLE}" "${MK_API_DOC_SCRIPT}"
  --build "${PROJECT_BINARY_DIR}"
  --doxygen-executable "${DOXYGEN_EXECUTABLE}"
  --output-dir "${DOC_DEST_DIR}"
  --temp-dir "${DOC_TEMP_DIR}"
  ${PYTHON_API_OPTIONS}
  ${DOTNET_API_OPTIONS}
  ${JAVA_API_OPTIONS}
  DEPENDS
    ${DOC_EXTRA_DEPENDS}
  COMMENT "Generating documentation"
  ${ADD_CUSTOM_TARGET_USES_TERMINAL_ARG}
)

# Remove generated documentation when running `clean` target.
set_property(DIRECTORY APPEND PROPERTY
  ADDITIONAL_MAKE_CLEAN_FILES
  "${DOC_DEST_DIR}"
)

option(Z3_INSTALL_API_BINDINGS_DOCUMENTATION "Install documentation for API bindings" ON)
set(CMAKE_INSTALL_API_BINDINGS_DOC
  "${CMAKE_INSTALL_DOCDIR}"
  CACHE
  PATH
  "Path to install documentation for API bindings"
)
if (Z3_INSTALL_API_BINDINGS_DOCUMENTATION)
  install(
    DIRECTORY "${DOC_DEST_DIR}"
    DESTINATION "${CMAKE_INSTALL_API_BINDINGS_DOC}"
  )
endif()

=== src/CMakeLists.txt ===
################################################################################
# API header files
################################################################################
# This lists the API header files that are scanned by
# some of the build rules to generate some files needed
# by the build
set(Z3_API_HEADER_FILES_TO_SCAN
  z3_api.h
  z3_ast_containers.h
  z3_algebraic.h
  z3_polynomial.h
  z3_rcf.h
  z3_fixedpoint.h
  z3_optimization.h
  z3_fpa.h
  z3_spacer.h
)
set(Z3_FULL_PATH_API_HEADER_FILES_TO_SCAN "")
foreach (header_file ${Z3_API_HEADER_FILES_TO_SCAN})
  set(full_path_api_header_file "${CMAKE_CURRENT_SOURCE_DIR}/api/${header_file}")
  list(APPEND Z3_FULL_PATH_API_HEADER_FILES_TO_SCAN "${full_path_api_header_file}")
  if (NOT EXISTS "${full_path_api_header_file}")
    message(FATAL_ERROR "API header file \"${full_path_api_header_file}\" does not exist")
  endif()
endforeach()

################################################################################
# Traverse directories each adding a Z3 component
################################################################################
# I'm duplicating the order in ``mk_project.py`` for now to help us keep
# the build systems in sync.
#
# The components in these directory explicitly declare their dependencies so
# you may be able to re-order some of these directories but an error will be
# raised if you try to declare a component is dependent on another component
# that has not yet been declared.
add_subdirectory(util)
add_subdirectory(math/polynomial)
add_subdirectory(sat)
add_subdirectory(nlsat)
add_subdirectory(util/lp)
add_subdirectory(math/hilbert)
add_subdirectory(math/simplex)
add_subdirectory(math/automata)
add_subdirectory(math/interval)
add_subdirectory(math/realclosure)
add_subdirectory(math/subpaving)
add_subdirectory(ast)
add_subdirectory(ast/rewriter)
add_subdirectory(ast/normal_forms)
add_subdirectory(model)
add_subdirectory(tactic)
add_subdirectory(ast/substitution)
add_subdirectory(parsers/util)
add_subdirectory(math/grobner)
add_subdirectory(math/euclid)
add_subdirectory(tactic/core)
add_subdirectory(math/subpaving/tactic)
add_subdirectory(tactic/aig)
add_subdirectory(solver)
add_subdirectory(sat/tactic)
add_subdirectory(tactic/arith)
add_subdirectory(nlsat/tactic)
add_subdirectory(ackermannization)
add_subdirectory(cmd_context)
add_subdirectory(cmd_context/extra_cmds)
add_subdirectory(parsers/smt2)
add_subdirectory(ast/proofs)
add_subdirectory(ast/fpa)
add_subdirectory(ast/macros)
add_subdirectory(ast/pattern)
add_subdirectory(ast/rewriter/bit_blaster)
add_subdirectory(smt/params)
add_subdirectory(smt/proto_model)
add_subdirectory(smt)
add_subdirectory(tactic/bv)
add_subdirectory(smt/tactic)
add_subdirectory(tactic/sls)
add_subdirectory(qe)
add_subdirectory(muz/base)
add_subdirectory(muz/dataflow)
add_subdirectory(muz/transforms)
add_subdirectory(muz/rel)
add_subdirectory(muz/clp)
add_subdirectory(muz/tab)
add_subdirectory(muz/bmc)
add_subdirectory(muz/ddnf)
add_subdirectory(muz/spacer)
add_subdirectory(muz/fp)
add_subdirectory(tactic/ufbv)
add_subdirectory(sat/sat_solver)
add_subdirectory(tactic/smtlogics)
add_subdirectory(tactic/fpa)
add_subdirectory(tactic/fd_solver)
add_subdirectory(tactic/portfolio)
add_subdirectory(opt)
add_subdirectory(api)
add_subdirectory(api/dll)

################################################################################
# libz3
################################################################################
get_property(Z3_LIBZ3_COMPONENTS_LIST GLOBAL PROPERTY Z3_LIBZ3_COMPONENTS)
set (object_files "")
foreach (component ${Z3_LIBZ3_COMPONENTS_LIST})
  list(APPEND object_files $<TARGET_OBJECTS:${component}>)
endforeach()
if (Z3_BUILD_LIBZ3_SHARED)
  set(lib_type "SHARED")
else()
  set(lib_type "STATIC")
endif()
add_library(libz3 ${lib_type} ${object_files})
set_target_properties(libz3 PROPERTIES
  # VERSION determines the version in the filename of the shared library.
  # SOVERSION determines the value of the DT_SONAME field on ELF platforms.
  # On ELF platforms the final compiled filename will be libz3.so.W.X.Y.Z
  # but symlinks will be made to this file from libz3.so and also from
  # libz3.so.W.X.
  # This indicates that no breaking API changes will be made within a single
  # minor version.
  VERSION ${Z3_VERSION}
  SOVERSION ${Z3_VERSION_MAJOR}.${Z3_VERSION_MINOR})

if (NOT MSVC)
  # On UNIX like platforms if we don't change the OUTPUT_NAME
  # the library gets a name like ``liblibz3.so`` so we change it
  # here. We don't do a rename with MSVC because we get file naming
  # conflicts (the z3 executable also has this OUTPUT_NAME) with
  # ``.ilk``, ``.pdb``, ``.lib`` and ``.exp`` files sharing the same
  # prefix.
  set_target_properties(libz3 PROPERTIES OUTPUT_NAME z3)
endif()

# The `PRIVATE` usage requirement is specified so that when building Z3 as a
# shared library the dependent libraries are specified on the link command line
# so that if those are also shared libraries they are referenced by `libz3.so`.
target_link_libraries(libz3 PRIVATE ${Z3_DEPENDENT_LIBS})

# This is currently only for the OpenMP flags. It needs to be set
# via `target_link_libraries()` rather than `z3_append_linker_flag_list_to_target()`
# because when building the `libz3` as a static library when the target is exported
# the link dependencies need to be exported too.
foreach (flag_name ${Z3_DEPENDENT_EXTRA_CXX_LINK_FLAGS})
  target_link_libraries(libz3 PRIVATE ${flag_name})
endforeach()

# Declare which header file are the public header files of libz3
# these will automatically installed when the libz3 target is installed
set (libz3_public_headers
  z3_algebraic.h
  z3_api.h
  z3_ast_containers.h
  z3_fixedpoint.h
  z3_fpa.h
  z3.h
  c++/z3++.h
  z3_macros.h
  z3_optimization.h
  z3_polynomial.h
  z3_rcf.h
  z3_v1.h
  z3_spacer.h
)
foreach (header ${libz3_public_headers})
  set_property(TARGET libz3 APPEND PROPERTY
    PUBLIC_HEADER "${PROJECT_SOURCE_DIR}/src/api/${header}")
endforeach()
set_property(TARGET libz3 APPEND PROPERTY
    PUBLIC_HEADER "${CMAKE_CURRENT_BINARY_DIR}/util/z3_version.h")

install(TARGETS libz3
  EXPORT Z3_EXPORTED_TARGETS
  LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
  ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}" # On Windows this installs ``libz3.lib`` which CMake calls the "corresponding import library". Do we want this installed?
  RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}" # For Windows. DLLs are runtime targets for CMake
  PUBLIC_HEADER DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}"
)

if (MSVC)
  # Handle settings dll exports when using MSVC
  # FIXME: This seems unnecessarily complicated but I'm doing
  # this because this is what the python build system does.
  # CMake has a much more elegant (see ``GenerateExportHeader.cmake``)
  # way of handling this.
  set(dll_module_exports_file "${CMAKE_CURRENT_BINARY_DIR}/api_dll.def")
  add_custom_command(OUTPUT "${dll_module_exports_file}"
    COMMAND
      "${PYTHON_EXECUTABLE}"
      "${PROJECT_SOURCE_DIR}/scripts/mk_def_file.py"
      "${dll_module_exports_file}"
      "libz3"
      ${Z3_FULL_PATH_API_HEADER_FILES_TO_SCAN}
    DEPENDS
      "${PROJECT_SOURCE_DIR}/scripts/mk_def_file.py"
      ${Z3_GENERATED_FILE_EXTRA_DEPENDENCIES}
      ${Z3_FULL_PATH_API_HEADER_FILES_TO_SCAN}
    COMMENT "Generating \"${dll_module_exports_file}\""
    ${ADD_CUSTOM_COMMAND_USES_TERMINAL_ARG}
    VERBATIM
  )
  add_custom_target(libz3_extra_depends
    DEPENDS "${dll_module_exports_file}"
  )
  add_dependencies(libz3 libz3_extra_depends)
  z3_append_linker_flag_list_to_target(libz3 "/DEF:${dll_module_exports_file}")
endif()

################################################################################
# Z3 executable
################################################################################
add_subdirectory(shell)

################################################################################
# z3-test
################################################################################
add_subdirectory(test)


################################################################################
# Z3 API bindings
################################################################################
option(Z3_BUILD_PYTHON_BINDINGS "Build Python bindings for Z3" OFF)
if (Z3_BUILD_PYTHON_BINDINGS)
  if (NOT Z3_BUILD_LIBZ3_SHARED)
    message(FATAL_ERROR "The python bindings will not work with a static libz3. "
            "You either need to disable Z3_BUILD_PYTHON_BINDINGS or enable Z3_BUILD_LIBZ3_SHARED")
  endif()
  add_subdirectory(api/python)
endif()

################################################################################
# .NET bindings
################################################################################
option(Z3_BUILD_DOTNET_BINDINGS "Build .NET bindings for Z3" OFF)
if (Z3_BUILD_DOTNET_BINDINGS)
  if (NOT Z3_BUILD_LIBZ3_SHARED)
    message(FATAL_ERROR "The .NET bindings will not work with a static libz3. "
      "You either need to disable Z3_BUILD_DOTNET_BINDINGS or enable Z3_BUILD_LIBZ3_SHARED")
  endif()
  add_subdirectory(api/dotnet)
endif()

################################################################################
# Java bindings
################################################################################
option(Z3_BUILD_JAVA_BINDINGS "Build Java bindings for Z3" OFF)
if (Z3_BUILD_JAVA_BINDINGS)
  if (NOT Z3_BUILD_LIBZ3_SHARED)
    message(FATAL_ERROR "The Java bindings will not work with a static libz3. "
      "You either need to disable Z3_BUILD_JAVA_BINDINGS or enable Z3_BUILD_LIBZ3_SHARED")
  endif()
  add_subdirectory(api/java)
endif()

# TODO: Implement support for other bindigns

=== examples/python/CMakeLists.txt ===
set(python_example_files
  all_interval_series.py
  complex/complex.py
  example.py
  hamiltonian/hamiltonian.py
  mus/marco.py
  mus/mss.py
  socrates.py
  visitor.py
)

set(z3py_bindings_build_dest "${PROJECT_BINARY_DIR}/python")

set(build_z3_python_examples_target_depends "")
foreach (example_file ${python_example_files})
  add_custom_command(OUTPUT "${z3py_bindings_build_dest}/${example_file}"
    COMMAND "${CMAKE_COMMAND}" "-E" "copy"
      "${CMAKE_CURRENT_SOURCE_DIR}/${example_file}"
      # We flatten the hierarchy so that all python files have
      # the `z3` directory in their directory so that their import
      # statements "just work".
      "${z3py_bindings_build_dest}/"
    DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/${example_file}"
    COMMENT "Copying \"${example_file}\" to ${z3py_bindings_build_dest}/${example_file}"
  )
  list(APPEND build_z3_python_examples_target_depends "${z3py_bindings_build_dest}/${example_file}")
endforeach()

add_custom_target(build_z3_python_examples
  ALL
  DEPENDS
    ${build_z3_python_examples_target_depends}
)

=== src/ast/CMakeLists.txt ===
z3_add_component(ast
  SOURCES
    act_cache.cpp
    arith_decl_plugin.cpp
    array_decl_plugin.cpp
    ast.cpp
    ast_ll_pp.cpp
    ast_lt.cpp
    ast_pp_util.cpp
    ast_printer.cpp
    ast_smt2_pp.cpp
    ast_smt_pp.cpp
    ast_pp_dot.cpp
    ast_translation.cpp
    ast_util.cpp
    bv_decl_plugin.cpp
    csp_decl_plugin.cpp
    datatype_decl_plugin.cpp
    decl_collector.cpp
    display_dimacs.cpp
    dl_decl_plugin.cpp
    expr2polynomial.cpp
    expr2var.cpp
    expr_abstract.cpp
    expr_functors.cpp
    expr_map.cpp
    expr_stat.cpp
    expr_substitution.cpp
    for_each_ast.cpp
    for_each_expr.cpp
    format.cpp
    fpa_decl_plugin.cpp
    func_decl_dependencies.cpp
    has_free_vars.cpp
    macro_substitution.cpp
    num_occurs.cpp
    occurs.cpp
    pb_decl_plugin.cpp
    pp.cpp
    recfun_decl_plugin.cpp
    reg_decl_plugins.cpp
    seq_decl_plugin.cpp
    shared_occs.cpp
    special_relations_decl_plugin.cpp
    static_features.cpp
    used_vars.cpp
    well_sorted.cpp
  COMPONENT_DEPENDENCIES
    polynomial
    util # Unnecessary? polynomial already depends on util
  PYG_FILES
    pp_params.pyg
)

=== src/model/CMakeLists.txt ===
z3_add_component(model
  SOURCES
    array_factory.cpp
    datatype_factory.cpp
    func_interp.cpp
    model2expr.cpp
    model_core.cpp
    model.cpp
    model_evaluator.cpp
    model_implicant.cpp
    model_pp.cpp
    model_smt2_pp.cpp
    model_v2_pp.cpp
    numeral_factory.cpp
    struct_factory.cpp
    value_factory.cpp
  COMPONENT_DEPENDENCIES
    rewriter
  PYG_FILES
    model_evaluator_params.pyg
    model_params.pyg
)

=== src/opt/CMakeLists.txt ===
z3_add_component(opt
  SOURCES
    maxlex.cpp
    maxres.cpp
    maxsmt.cpp
    opt_cmds.cpp
    opt_context.cpp
    opt_pareto.cpp
    opt_parse.cpp
    optsmt.cpp
    opt_solver.cpp
    pb_sls.cpp
    sortmax.cpp
    wmax.cpp
  COMPONENT_DEPENDENCIES
    sat_solver
    sls_tactic
    smt
    smtlogic_tactics
  PYG_FILES
    opt_params.pyg
)

=== src/qe/CMakeLists.txt ===
z3_add_component(qe
  SOURCES
    nlarith_util.cpp
    nlqsat.cpp
    qe_arith.cpp
    qe_arith_plugin.cpp
    qe_array_plugin.cpp
    qe_arrays.cpp
    qe_bool_plugin.cpp
    qe_bv_plugin.cpp
    qe_cmd.cpp
    qe.cpp
    qe_datatype_plugin.cpp
    qe_datatypes.cpp
    qe_dl_plugin.cpp
    qe_lite.cpp
    qe_mbp.cpp
    qe_mbi.cpp
    qe_sat_tactic.cpp
    qe_solve_plugin.cpp
    qe_tactic.cpp
    qe_term_graph.cpp
    qsat.cpp
  COMPONENT_DEPENDENCIES
    nlsat_tactic
    nlsat
    sat
    smt
    tactic
  TACTIC_HEADERS
    nlqsat.h
    qe_lite.h
    qe_sat_tactic.h
    qe_tactic.h
    qsat.h
)

=== src/sat/CMakeLists.txt ===
z3_add_component(sat
  SOURCES
    ba_solver.cpp
    dimacs.cpp
    sat_asymm_branch.cpp
    sat_bdd.cpp
    sat_big.cpp
    sat_clause.cpp
    sat_clause_set.cpp
    sat_clause_use_list.cpp
    sat_cleaner.cpp
    sat_config.cpp
    sat_ddfw.cpp
    sat_drat.cpp
    sat_elim_eqs.cpp
    sat_elim_vars.cpp
    sat_iff3_finder.cpp
    sat_integrity_checker.cpp
    sat_local_search.cpp
    sat_lookahead.cpp
    sat_model_converter.cpp
    sat_mus.cpp
    sat_parallel.cpp
    sat_prob.cpp
    sat_probing.cpp
    sat_scc.cpp
    sat_simplifier.cpp
    sat_solver.cpp
    sat_unit_walk.cpp
    sat_watched.cpp
  COMPONENT_DEPENDENCIES
    util
  PYG_FILES
    sat_asymm_branch_params.pyg
    sat_params.pyg
    sat_scc_params.pyg
    sat_simplifier_params.pyg
)

=== src/shell/CMakeLists.txt ===
set (shell_object_files "")
# FIXME: z3 should really link against libz3 and not the
# individual components. Several things prevent us from
# doing this
# * The api_dll component in libz3 shouldn't be used the
#   the z3 executable.
# * The z3 executable uses symbols that are hidden in libz3

# We are only using these dependencies to enforce a build
# order. We don't use this list for actual linking.
set(shell_deps api extra_cmds opt sat)
z3_expand_dependencies(shell_expanded_deps ${shell_deps})
get_property(Z3_LIBZ3_COMPONENTS_LIST GLOBAL PROPERTY Z3_LIBZ3_COMPONENTS)
foreach (component ${Z3_LIBZ3_COMPONENTS_LIST})
  if (NOT ("${component}" STREQUAL "api_dll"))
    # We don't use the api_dll component in the Z3 executable
    list(APPEND shell_object_files $<TARGET_OBJECTS:${component}>)
  endif()
endforeach()
add_executable(shell
  datalog_frontend.cpp
  dimacs_frontend.cpp
  "${CMAKE_CURRENT_BINARY_DIR}/gparams_register_modules.cpp"
  "${CMAKE_CURRENT_BINARY_DIR}/install_tactic.cpp"
  main.cpp
  "${CMAKE_CURRENT_BINARY_DIR}/mem_initializer.cpp"
  opt_frontend.cpp
  smtlib_frontend.cpp
  z3_log_frontend.cpp
  lp_frontend.cpp
# FIXME: shell should really link against libz3 but it can't due to requiring
# use of some hidden symbols. Also libz3 has the ``api_dll`` component which
# we don't want (I think).
  ${shell_object_files}
)
z3_add_install_tactic_rule(${shell_deps})
z3_add_memory_initializer_rule(${shell_deps})
z3_add_gparams_register_modules_rule(${shell_deps})
set_target_properties(shell PROPERTIES OUTPUT_NAME z3)
target_compile_definitions(shell PRIVATE ${Z3_COMPONENT_CXX_DEFINES})
target_compile_options(shell PRIVATE ${Z3_COMPONENT_CXX_FLAGS})
target_include_directories(shell PRIVATE ${Z3_COMPONENT_EXTRA_INCLUDE_DIRS})
target_link_libraries(shell PRIVATE ${Z3_DEPENDENT_LIBS})
z3_add_component_dependencies_to_target(shell ${shell_expanded_deps})
z3_append_linker_flag_list_to_target(shell ${Z3_DEPENDENT_EXTRA_CXX_LINK_FLAGS})
install(TARGETS shell
  RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
)

=== src/smt/CMakeLists.txt ===
z3_add_component(smt
  SOURCES
    arith_eq_adapter.cpp
    arith_eq_solver.cpp
    asserted_formulas.cpp
    cached_var_subst.cpp
    cost_evaluator.cpp
    dyn_ack.cpp
    elim_term_ite.cpp
    expr_context_simplifier.cpp
    fingerprints.cpp
    mam.cpp
    old_interval.cpp
    qi_queue.cpp
    smt_almost_cg_table.cpp
    smt_arith_value.cpp
    smt_case_split_queue.cpp
    smt_cg_table.cpp
    smt_checker.cpp
    smt_clause.cpp
    smt_clause_proof.cpp
    smt_conflict_resolution.cpp
    smt_consequences.cpp
    smt_context.cpp
    smt_context_inv.cpp
    smt_context_pp.cpp
    smt_context_stat.cpp
    smt_enode.cpp
    smt_farkas_util.cpp
    smt_for_each_relevant_expr.cpp
    smt_implied_equalities.cpp
    smt_internalizer.cpp
    smt_justification.cpp
    smt_kernel.cpp
    smt_literal.cpp
    smt_lookahead.cpp
    smt_model_checker.cpp
    smt_model_finder.cpp
    smt_model_generator.cpp
    smt_quantifier.cpp
    smt_quantifier_stat.cpp
    smt_quick_checker.cpp
    smt_relevancy.cpp
    smt_setup.cpp
    smt_solver.cpp
    smt_statistics.cpp
    smt_theory.cpp
    smt_value_sort.cpp
    smt2_extra_cmds.cpp
    theory_arith.cpp
    theory_array_bapa.cpp
    theory_array_base.cpp
    theory_array.cpp
    theory_array_full.cpp
    theory_bv.cpp
    theory_datatype.cpp
    theory_dense_diff_logic.cpp
    theory_diff_logic.cpp
    theory_dl.cpp
    theory_dummy.cpp
    theory_fpa.cpp
    theory_jobscheduler.cpp
    theory_lra.cpp
    theory_opt.cpp
    theory_pb.cpp
    theory_recfun.cpp
    theory_seq.cpp
    theory_special_relations.cpp
    theory_str.cpp
    theory_str_regex.cpp
    theory_utvpi.cpp
    theory_wmaxsat.cpp
    uses_theory.cpp
    watch_list.cpp
  COMPONENT_DEPENDENCIES
    bit_blaster
    cmd_context
    euclid
    fpa
    grobner
    nlsat
    lp
    macros
    normal_forms
    parser_util
    pattern
    proofs
    proto_model
    simplex
    substitution
)

=== src/solver/CMakeLists.txt ===
z3_add_component(solver
  SOURCES
    check_sat_result.cpp
    combined_solver.cpp
    mus.cpp
    parallel_tactic.cpp
    smt_logics.cpp
    solver.cpp
    solver_na2as.cpp
    solver_pool.cpp
    solver2tactic.cpp
    tactic2solver.cpp
  COMPONENT_DEPENDENCIES
    model
    tactic
  PYG_FILES
    combined_solver_params.pyg
    parallel_params.pyg
  PYG_FILES
    solver_params.pyg

)

=== debian/changelog ===
z3 (4.8.7-4build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:29:12 +0100

z3 (4.8.7-4) unstable; urgency=medium

  * Remove all :all and :native annotations from the build dependencies in
    debian/control (Closes: #948763).

 -- Fabian Wolff <fabi.wolff@arcor.de>  Mon, 13 Jan 2020 22:55:52 +0100

z3 (4.8.7-3) unstable; urgency=medium

  * Use the CMake build system instead of upstream's custom Python build
    scripts.
  * Drop libz3-ocaml-dev package (this package is currently broken, can't
    be built with CMake and causes lots of maintenance effort while having
    no reverse dependencies (or users, for that matter, who would have had
    to notice that the package doesn't actually work).
  * Update patches:
    - Drop 00-avoid-ocamlopt.patch (no longer needed since we removed
      OCaml support).
    - Drop 02-hardening.patch (no longer needed because it applies to the
      old build system).
    - Drop 03-kfreebsd.patch (also applies to the old build system).
    - Renumber remaining patches:
      + 01-intrinsics.patch -> 00-intrinsics.patch
      + 05-reproducibility.patch -> 01-reproducibility.patch
      + 04-soname.patch -> 02-soname.patch
        (updated for the CMake build system)
    - Add new 03-pthread.patch (thanks to Aurelien Jarno for this!)
      (Closes: #948109).
  * Build Java bindings on riscv64.
  * Upgrade watch file to version 4 format (no changes).
  * Drop Michael Tautschnig <mt@debian.org> from Uploaders (he hasn't done
    an upload for this package in over four years and never responded to
    any of my emails to him).

 -- Fabian Wolff <fabi.wolff@arcor.de>  Fri, 10 Jan 2020 16:35:48 +0100

z3 (4.8.7-2) unstable; urgency=medium

  * Adjust 01-intrinsics.patch to try to fix build failures on many
    32-bit architectures (patch tested on i386) (Closes: #946448).

 -- Fabian Wolff <fabi.wolff@arcor.de>  Mon, 09 Dec 2019 13:39:38 +0100

z3 (4.8.7-1) unstable; urgency=medium

  * New upstream release.
  * Refresh patches.
  * Replace libnum-ocaml-dev build dependency with libzarith-ocaml-dev
    and add ocaml-findlib.
  * Use ocamlopt when available (instead of disabling it for all
    architectures).

 -- Fabian Wolff <fabi.wolff@arcor.de>  Sun, 08 Dec 2019 21:59:24 +0100

=== debian/control ===
Source: z3
Section: science
Priority: optional
Maintainer: LLVM Packaging Team <pkg-llvm-team@lists.alioth.debian.org>
Uploaders: Fabian Wolff <fabi.wolff@arcor.de>
Build-Depends: debhelper-compat (= 12),
               dh-python, python3, cmake,
               javahelper [!hppa !hurd-i386 !m68k !sh4],
               default-jdk [!hppa !hurd-i386 !m68k !sh4]
Standards-Version: 4.4.1
Homepage: https://github.com/Z3Prover/z3
Vcs-Git: https://salsa.debian.org/pkg-llvm-team/z3.git
Vcs-Browser: https://salsa.debian.org/pkg-llvm-team/z3

Package: z3
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: theorem prover from Microsoft Research
 Z3 is a state-of-the art theorem prover from Microsoft Research. It can be
 used to check the satisfiability of logical formulas over one or more
 theories. Z3 offers a compelling match for software analysis and verification
 tools, since several common software constructs map directly into supported
 theories.
 .
 The Z3 input format is an extension of the one defined by the SMT-LIB 2.0
 standard.

Package: libz3-4
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Breaks: libz3-dev (<< 4.4.1)
Replaces: libz3-dev (<< 4.4.1)
Description: theorem prover from Microsoft Research - runtime libraries
 Z3 is a state-of-the art theorem prover from Microsoft Research. It can be
 used to check the satisfiability of logical formulas over one or more
 theories. Z3 offers a compelling match for software analysis and verification
 tools, since several common software constructs map directly into supported
 theories.
 .
 This package contains runtime libraries. You shouldn't have to install it
 manually.

Package: libz3-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libz3-4 (= ${binary:Version}), ${misc:Depends}
Description: theorem prover from Microsoft Research - development files
 Z3 is a state-of-the art theorem prover from Microsoft Research. It can be
 used to check the satisfiability of logical formulas over one or more
 theories. Z3 offers a compelling match for software analysis and verification
 tools, since several common software constructs map directly into supported
 theories.
 .
 This package can be used to invoke Z3 via its C++ API.

Package: python3-z3
Section: python
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libz3-dev (= ${binary:Version}),
         python3-pkg-resources,
         ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Description: theorem prover from Microsoft Research - Python 3 bindings
 Z3 is a state-of-the art theorem prover from Microsoft Research. See the z3
 package for a detailed description.
 .
 This package can be used to invoke Z3 via its Python 3 API.

Package: libz3-java
Section: java
Architecture: amd64 arm64 armel armhf i386 mips mips64el mipsel powerpc ppc64el s390x alpha kfreebsd-amd64 kfreebsd-i386 powerpcspe riscv64 sparc64 x32
Multi-Arch: foreign
Depends: libz3-jni (>= ${binary:Version}), libz3-jni (<< ${source:Version}.1~), libz3-dev, ${misc:Depends}, ${java:Depends}
Description: theorem prover from Microsoft Research - java bindings
 Z3 is a state-of-the art theorem prover from Microsoft Research. See the z3
 package for a detailed description.
 .
 This package can be used to invoke Z3 via its Java API.

Package: libz3-jni
Section: java
Architecture: amd64 arm64 armel armhf i386 mips mips64el mipsel powerpc ppc64el s390x alpha kfreebsd-amd64 kfreebsd-i386 powerpcspe riscv64 sparc64 x32
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libz3-dev (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: theorem prover from Microsoft Research - JNI library
 Z3 is a state-of-the art theorem prover from Microsoft Research. See the z3
 package for a detailed description.
 .
 This package provides the JNI library to invoke Z3 via its Java API.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CXXFLAGS_MAINT_APPEND = -fPIC

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

ifneq (,$(shell dh_listpackages -a | grep libz3-jni))
    WITH_JAVA ?= ON
    WITH_JAVAHELPER ?= ,javahelper
else
    WITH_JAVA ?= OFF
    WITH_JAVAHELPER ?=
endif

%:
	dh $@ --with python3$(WITH_JAVAHELPER)

override_dh_auto_configure:
	dh_auto_configure --buildsystem=cmake+makefile -- \
		-DCMAKE_INSTALL_PYTHON_PKG_DIR=lib/python3/dist-packages \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		-DZ3_BUILD_PYTHON_BINDINGS=ON \
		-DZ3_BUILD_DOTNET_BINDINGS=OFF \
		-DZ3_BUILD_JAVA_BINDINGS=$(WITH_JAVA)

override_dh_installchangelogs:
	dh_installchangelogs RELEASE_NOTES
	for p in python3-z3 libz3-java libz3-jni ; do \
		$(RM) -rf debian/$$p/usr/share/doc/$$p/ ; \
		ln -s libz3-dev debian/$$p/usr/share/doc/$$p || true ; \
	done

=== debian/tests/control ===
Tests: import-z3-test include-z3-test run-z3-test
Depends: @, build-essential, python3
Restrictions: superficial

Tests: z3-int-logic-test python3-z3-int-logic-test
Depends: @, build-essential, python3
